src/app/main/views.py
from flask import Blueprint, render_template, flash, redirect, url_for

from .forms.EditPriceForm import EditPriceForm
from .. import db
from ..blueprints.stats.services.statistics import Statistics
from ..models import PriceList

main = Blueprint('main', __name__)


@main.route('/')
def view_home_page():
    price_query = Statistics.get_price_list()
    data = {
        'stats': {
            'Noviny': 1200,
            'Železo': 980,
            'Měď': 375,
            'Hliník': 525,
            'Olovo': 692,
        },
        'prices': price_query
    }
    return render_template('main/homepage.jinja2', title='Domovská stránka', data=data)


@main.route('/greet')
def view_greeting_page():
    return render_template('main/greet.jinja2', title='Greeting', greeting='Hello')


@main.route('/prices')
def add_material_prices():
    price_query = Statistics.get_price_list()

    return render_template('main/price_list.jinja2', title='Ceník', prices_request=price_query)


@main.route('/prices/edit', methods=['GET', 'POST'])
def edit_material_price():
    form = EditPriceForm()

    if form.validate_on_submit():
        new_price = PriceList(form.opts.data.material_id, form.price.data)
        db.session.add(new_price)
        db.session.commit()
        flash("Cena materiálu byla úspešně aktualizována", 'success')
        return redirect(url_for('main.add_material_prices'))
    return render_template("main/EditPriceList.jinja2", form=form)

src/app/user/views.py
from flask import Blueprint, render_template, redirect, url_for, flash, abort
from flask_login import current_user, login_required
from sqlalchemy import desc

from . import get_user_attributes
from .forms import ChangePasswordform, ChangePersonalForm, ChangeAddressForm
from .. import db
from ..blueprints.stats.services.statistics import Statistics
from ..decorators import permission_required
from ..models import User, Permission, Purchase, UserStatus, Status, Address


user = Blueprint('user', __name__)


@user.route('/change/password', methods=['GET', 'POST'])
@login_required
@permission_required(Permission.SELF_MANAGEMENT)
def view_change_password_page():
    form = ChangePasswordform()

    if form.validate_on_submit():
        current_user.password = form.password.data

        db.session.commit()

        flash('Změna hesla proběhla úspěšně')
        return redirect(url_for('auth.logout'))
    return render_template('user/changePassword.jinja2', title='zmena', form=form)


@user.route('<id>/settings', methods=['GET', 'POST'])
@login_required
@permission_required(Permission.SELF_MANAGEMENT)
def view_change_personal_page(id):
    # Page is only accessible by workers and user it belongs to
    if not ((current_user.user_id == int(id)) or current_user.is_administrator() or current_user.is_worker()):
        abort(403)

    edited_user = User.query.get_or_404(id)

    form = ChangePersonalForm()

    if form.validate_on_submit():
        edited_user.first_name = form.first_name.data
        edited_user.last_name = form.last_name.data
        edited_user.telephone_number = form.telephone_number.data

        db.session.commit()

        flash('Změna údajů proběhla úspěšně')
        return redirect(url_for('user.view_dashboard_page'))

    return render_template('user/changePersonal.jinja2', title='zmena', form=form, user=edited_user)


@user.route('<id>/change/address/primary', methods=['GET', 'POST'])
@login_required
@permission_required(Permission.SELF_MANAGEMENT)
def view_change_address_page(id):
    # Page is only accessible by workers and user it belongs to
    if not ((current_user.user_id == int(id)) or current_user.is_administrator() or current_user.is_worker()):
        abort(403)

    edited_user = User.query.get_or_404(id)

    form = ChangeAddressForm()
    if form.validate_on_submit():
        address = Address(
            form.street.data,
            form.house_number.data,
            form.city.data,
            form.zip_code.data
        )
        edited_user.permanent_residence = address
        db.session.add(address)
        db.session.commit()

        flash('Změna údajů proběhla úspěšně')
        return redirect(url_for('user.view_dashboard_page'))
    return render_template('user/changeAddress.jinja2', title='Změna adresy', form=form)


@user.route('<id>/change/address/secondary', methods=['GET', 'POST'])
@login_required
@permission_required(Permission.SELF_MANAGEMENT)
def view_change_secondary_address_page(id):
    # Page is only accessible by workers and user it belongs to
    if not ((current_user.user_id == int(id)) or current_user.is_administrator() or current_user.is_worker()):
        abort(403)

    edited_user = User.query.get_or_404(id)

    form = ChangeAddressForm()
    if form.validate_on_submit():
        address = Address(
            form.street.data,
            form.house_number.data,
            form.city.data,
            form.zip_code.data
        )
        edited_user.temporary_residence = address
        db.session.add(address)
        db.session.commit()

        flash('Změna údajů proběhla úspěšně')
        return redirect(url_for('user.view_dashboard_page'))
    return render_template('user/changeSecondAddress.jinja2', title='Změna sekundární adresy', form=form)


@user.route('/dashboard')
@login_required
@permission_required(Permission.ACCESS)
def view_dashboard_page():
    user_attributes = get_user_attributes(current_user)
    price_list = Statistics.get_price_list()

    waiting_status = Status.query.filter_by(name=UserStatus.WAITING.value).first()

    registration_requests = User.query \
        .filter_by(status_id=waiting_status.status_id) \
        .order_by(User.user_id) \
        .limit(5) \
        .all()

    if current_user.is_administrator() or current_user.is_worker():
        purchases = Purchase.query. \
            filter_by(buying_employee_id=current_user.user_id) \
            .order_by(desc(Purchase.date)) \
            .limit(5) \
            .all()
    else:
        purchases = Purchase.query. \
            filter_by(selling_customer_id=current_user.user_id) \
            .order_by(desc(Purchase.date)) \
            .limit(5) \
            .all()
    stats = Statistics(current_user)
    total = stats.this_months_money()

    data = dict(user_attributes=user_attributes, registration_requests=registration_requests, price_list=price_list,
                purchases=purchases, total=total)
    return render_template("user/dashboard.jinja2", title=f"Přehled uživatele {current_user.login}", data=data)


@user.route('/<id>/confirm')
@login_required
@permission_required(Permission.USER_ADMINISTRATION)
def confirm_user(id):
    searched_user = User.query.get_or_404(id)
    if searched_user.status.name == UserStatus.WAITING.value:
        searched_user.confirm()
        db.session.commit()
        flash(f"Registrace uživatele {searched_user.login} potvrzena", 'success')
    return redirect(url_for('admin.view_users_page'))


@user.route('<id>/ban')
@login_required
@permission_required(Permission.USER_ADMINISTRATION)
def ban_user(id):
    searched_user = User.query.get_or_404(id)
    if searched_user.status.name == UserStatus.ACTIVE.value:
        searched_user.ban()
        db.session.commit()
        flash(f"Uživatel {searched_user.login} byl zablokován", 'warning')
    return redirect(url_for('admin.view_users_page'))


@user.route('<id>/unban')
@login_required
@permission_required(Permission.USER_ADMINISTRATION)
def unban_user(id):
    searched_user = User.query.get_or_404(id)
    if searched_user.status.name == UserStatus.BANNED.value:
        searched_user.unban()
        db.session.commit()
        flash(f"Uživatel {searched_user.login} byl odblokován", 'warning')
    return redirect(url_for('admin.view_users_page'))


@user.route('<id>')
@login_required
def view_profile_page(id: int):
    # Page is only accessible by workers and user it belongs to
    if not ((current_user.user_id == int(id)) or current_user.is_administrator() or current_user.is_worker()):
        abort(403)

    found_user = User.query.get_or_404(id)

    s = Statistics(found_user)
    stats = s.this_months_money()

    if found_user.is_administrator() or found_user.is_worker():
        purchases = Purchase.query. \
            filter_by(buying_employee_id=found_user.user_id) \
            .order_by(Purchase.purchase_id) \
            .limit(5) \
            .all()
    else:
        purchases = Purchase.query. \
            filter_by(selling_customer_id=found_user.user_id) \
            .order_by(Purchase.purchase_id) \
            .limit(5) \
            .all()

    data = dict(user=found_user, purchases=purchases, stats=stats)
    return render_template('user/profile.jinja2', data=data,
                           title=f"Profil {found_user.first_name} {found_user.last_name}")

src/app/templates/__components/__footer.jinja2
<footer>
    <div>
        <h3>Jména tvůrců</h3>
        <ul>
        <li>
            Libor Randula
        </li>
        <li>
            Filip Synek
        </li>
        <li>
          Tomáš Zatloukal
        </li>
      </ul>
        <span>&copy;2022-2023 MojeSberna</span>
    </div>

</footer>

src/app/templates/__components/__nav.jinja2
<nav>
    <a href="{{ url_for('main.view_home_page') }}">
        <img class="logo" src="{{ url_for('static', filename='img/logo.svg') }}" alt="logo">
    </a>
    <div class="hamburger">
        <span
                class="material-symbols-outlined"
                onclick="document.getElementById('menu-items').classList.toggle('visible')"
        >
            menu
        </span>
    </div>
    <ul id="menu-items" class="menu-items">

        <li><a href="{{ url_for('main.view_home_page') }}">Domů</a></li>
        {% if current_user.is_authenticated %}
            <li><a href="{{ url_for('user.view_dashboard_page') }}">Přehled</a></li>
            <li><a href="{{ url_for('purchase.view_purchases_page') }}">Výkupy</a></li>
        {% endif %}
        <li><a href="{{ url_for('main.view_home_page') }}#about-us">O nás</a></li>
        <li><a href="{{ url_for('main.add_material_prices') }}">Ceník</a></li>
        <li><a href="{{ url_for('main.view_home_page') }}#contacts">Kontakt</a></li>

        {% if not current_user.is_authenticated %}
            <li><a href="{{ url_for('auth.view_register_page') }}">Registrace</a></li>
            <li><a href="{{ url_for('auth.view_login_page') }}">Přihlásit se</a></li>
        {% else %}
            {% if current_user.is_administrator() %}
                <li class="has-dropdown"><a href="#">Administrace <span
                        class="material-symbols-outlined">expand_more</span></a>
                    <ul class="dropdown">
                        <li class="dropdown--item"><a href="{{ url_for('admin.view_users_page') }}">Přehled
                            uživatelů</a></li>
                    </ul>
                </li>
            {% endif %}
            <li class="has-dropdown"><a href="#">{{ current_user.login }} <span class="material-symbols-outlined">expand_more</span></a>
                <ul class="dropdown">
                    <li class="dropdown--item"><a
                            href="{{ url_for('user.view_profile_page', id=current_user.user_id) }}">Profil</a></li>
                    <li class="dropdown--item"><a
                            href="{{ url_for('user.view_change_personal_page',id=current_user.user_id) }}">Nastavení</a>
                    </li>
                    <li class="dropdown--item"><a href="{{ url_for('auth.logout') }}">Odhlásit se</a></li>
                </ul>
            </li>

        {% endif %}
    </ul>
</nav>